# atomic_store, atomic_store_explicit

From cppreference.com
< c‎ | atomic

Defined in header `<stdatomic.h>` |  |
void atomic_store( volatile A* obj , C desired); | (1) | (since C11)
void atomic_store_explicit( volatile A* obj, C desired, memory_order order ); | (2) | (since C11)

Atomically replaces the value of the atomic variable pointed to by `obj` with `desired`. The operation is atomic write operation.

The first version orders memory accesses according to memory_order_seq_cst, the second version orders memory accesses according to `order`. `order` must be one of memory_order_relaxed, memory_order_release or memory_order_seq_cst. Otherwise the behavior is undefined.

This is a generic function defined for all atomic object types `A`. The argument is pointer to a volatile atomic type to accept addresses of both non-volatile and volatile (e.g. memory-mapped I/O) atomic variables.`C` is the non-atomic type corresponding to `A`.

### Parameters

obj | - | pointer to the atomic object to modify
order | - | the memory synchronization ordering for this operation

### Return value

(none)

### References

- C11 standard (ISO/IEC 9899:2011):

  - 7.17.7.1 The atomic_store generic functions (p: 282)

### See also

atomic_load atomic_load_explicit (C11) | reads a value from an atomic object (function)
C++ documentation for atomic_store, atomic_store_explicit

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=c/atomic/atomic_store&oldid=81125"